package java2D1zusatz;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.awt.geom.*;



public class PainterView extends JFrame {
    JRadioButton circleRadioButton = new JRadioButton("Kreis",false);
    
    JRadioButton roundRectRadioButton = new JRadioButton("RundBox",false);
    
    JRadioButton arcRadioButton = new JRadioButton("Bogen",false);
    
    JRadioButton rectRadioButton = new JRadioButton("Rechteck",false);
    
    JRadioButton gPathRadioButton = new JRadioButton("Pfad", false);
    
    JRadioButton fillEvenOddRadioButton = new JRadioButton("Even_Odd", false);
    
    JRadioButton fillNonZeroRadioButton = new JRadioButton("Non_Zero", false);
    
    JButton clearButton = new JButton("clear");
    JButton rotButton = new JButton("rot_r");
    
    JRadioButton redRadioButton = new JRadioButton("Rot",false);
    JRadioButton blueRadioButton = new JRadioButton("Blau",false);
    
    JRadioButton gradientRadioButton = new JRadioButton("Gradient",false);
    
    JRadioButton addModeRadioButton = new JRadioButton("ADD",false);
    JRadioButton selectModeRadioButton = new JRadioButton("SELECT",false);
    
    JPanel modePanel = new JPanel();
    ButtonGroup modeButtonGroup = new ButtonGroup();
    
    JPanel buttonGroupPanel = new JPanel();
    JRadioButton textRadioButton = new JRadioButton("Textur",false);
    
    
    ButtonGroup shapeButtonGroup;
    ButtonGroup colorChooserButtonGroup;
    ButtonGroup windingRuleButtonGroup;
    RenderCanvas canvas;
    
    JCheckBox ditheringCheckbox = new JCheckBox("Dithering");
    JCheckBox antiAliasingCheckBox = new JCheckBox("AntiAlaising");
    JTextField rotAngleField = new JTextField("0",6);
    
    JPanel renderingPanel = new JPanel();
    JPanel lowerPanel = new JPanel();
    JPanel buttonPanel = new JPanel();
    JPanel upperPanel = new JPanel();
    JPanel windingRulePanel = new JPanel();
    JPanel colorPanel = new JPanel();
    JPanel allPanel = new JPanel();
    

    CanvasModel cm = new CanvasModel();
    
    public PainterView(String titel) {
        
        super(titel);
        this.getContentPane().setLayout(new BorderLayout());
 
        //Shapes
        circleRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getCircle());
            }
        });
        rectRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getRect());
            }
        });
        roundRectRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getRoundRect());
            }
        });
        arcRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getArc());
            }
        });
        gPathRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setShapeOption(DrawUtils.getInstance().getGeneralPath());
            }
        });
        
                ////BUTTONGROUP///////////
        shapeButtonGroup = new ButtonGroup();
        
        
        shapeButtonGroup.add(circleRadioButton);
        buttonGroupPanel.add(circleRadioButton);
        shapeButtonGroup.add(roundRectRadioButton);
        buttonGroupPanel.add(roundRectRadioButton);
        shapeButtonGroup.add(arcRadioButton);
        buttonGroupPanel.add(arcRadioButton);
        shapeButtonGroup.add(rectRadioButton);
        buttonGroupPanel.add(rectRadioButton);
        shapeButtonGroup.add(this.gPathRadioButton);
        buttonGroupPanel.add(this.gPathRadioButton);
        
        upperPanel.add(buttonGroupPanel);

        //Winding rules for path
        this.fillEvenOddRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ((GeneralPath)DrawUtils.getInstance().getGeneralPath()).setWindingRule(GeneralPath.WIND_EVEN_ODD);
            }
        });
        
        this.fillNonZeroRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                ((GeneralPath)DrawUtils.getInstance().getGeneralPath()).setWindingRule(GeneralPath.WIND_NON_ZERO);
            }
        });
        

        windingRuleButtonGroup = new  ButtonGroup();
        
        this.windingRuleButtonGroup.add(fillEvenOddRadioButton);
        this.windingRuleButtonGroup.add(fillNonZeroRadioButton);
        
        this.windingRulePanel.add(fillEvenOddRadioButton);
        this.windingRulePanel.add(fillNonZeroRadioButton);
        
        upperPanel.add(windingRulePanel);
        
        ////////////////////////////////
        
        /////Buttons+Textfield
        
        
        buttonPanel.add(clearButton);
        buttonPanel.add(rotButton);
        clearButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                cm.clear();
                State.setSelectedObject(null);
                canvas.repaint();
            }
        });
        
        rotButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.addAngle(45);
                rotAngleField.setText((double)State.getAngle()%360.0d+"");
            }
        });
        
        rotAngleField.setEditable(false);
               
        
        lowerPanel.add(buttonPanel);
        lowerPanel.add(rotAngleField);
        ////////////////////////
        
        //////FARBEN////

        
        
        redRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setFillOption(DrawUtils.getInstance().getRedPaint());
            }
        });
        
        blueRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                State.setFillOption(DrawUtils.getInstance().getBluePaint());
                
            }
        });
        
        gradientRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                State.setFillOption(DrawUtils.getInstance().getGradientPaint());
                
            }
        });
        
        textRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                
                State.setFillOption(DrawUtils.getInstance().getTextPaint());
                
            }
        });
        

        colorChooserButtonGroup = new ButtonGroup();
        
        colorChooserButtonGroup.add(redRadioButton);        
        colorChooserButtonGroup.add(blueRadioButton);
        colorChooserButtonGroup.add(gradientRadioButton);
        colorChooserButtonGroup.add(textRadioButton);
        
        
        colorPanel.add(redRadioButton);
        colorPanel.add(blueRadioButton);
        colorPanel.add(gradientRadioButton);
        colorPanel.add(textRadioButton);
        
        lowerPanel.add(colorPanel);
        /////////////////
        
        ///////////Nachbearbeitungen
        ditheringCheckbox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (ditheringCheckbox.isSelected()) {
                    State.setDithering(true);
                } else {
                    State.setAntialiasing(false);
                }
            }
        });
        
        this.antiAliasingCheckBox.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (antiAliasingCheckBox.isSelected()) {
                    State.setAntialiasing(true);
                } else {
                    State.setAntialiasing(false);
                }
            }
        });
        renderingPanel.add(ditheringCheckbox);
        renderingPanel.add(antiAliasingCheckBox);
        lowerPanel.add(renderingPanel);
        
        ////////////////////////////
        
        this.selectModeRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if (antiAliasingCheckBox.isSelected()) {
                    State.setAntialiasing(true);
                } else {
                    State.setAntialiasing(false);
                }
            }
        });
        this.addModeRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                State.setCurrentMode(State.MODE_ADD); 
                enableComponents(colorPanel, true);
                enableComponents(buttonGroupPanel,true);
            }
        });        
        
        
        this.selectModeRadioButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                enableComponents(colorPanel, false);
                enableComponents(buttonGroupPanel,false);

                State.setCurrentMode(State.MODE_SELECT); 
            }
        });        
        
        modeButtonGroup.add(selectModeRadioButton);
        modeButtonGroup.add(addModeRadioButton);
        modePanel.add(selectModeRadioButton);
        modePanel.add(addModeRadioButton);
        upperPanel.add(modePanel);
        
        
        allPanel.setLayout(new BorderLayout());
        allPanel.add(upperPanel, BorderLayout.NORTH);
        allPanel.add(lowerPanel, BorderLayout.SOUTH);
        
        this.getContentPane().add(allPanel, BorderLayout.NORTH);
        this.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        canvas = new RenderCanvas(cm, this);
        this.getContentPane().add(canvas, BorderLayout.SOUTH);
        canvas.repaint();
        
    }
    
    private void enableComponents(Container c, boolean b) {
        Component[] comps = c.getComponents();
        for (int i=0; i<comps.length; i++) {
          comps[i].setEnabled(b);
        }
    }
    
    public void updateView() {
        GeometricObject s = State.getSelectedObject();
        if (State.getCurrentMode()==State.MODE_SELECT&&s!=null) {

            DrawUtils u = DrawUtils.getInstance();
            Paint p = s.getPaint();
            Shape sh = s.getShape();
            AffineTransform at = s.getTransform();
            //set paint selection            
            if (p.equals(u.getBluePaint())) {
                this.blueRadioButton.setSelected(true);
            } 
            else if (p.equals(u.getRedPaint())) {
                this.redRadioButton.setSelected(true);
            }
            else if (p.equals(u.getTextPaint())) {
                this.textRadioButton.setSelected(true);
            }
            else if (p.equals(u.getGradientPaint())) {
                this.gradientRadioButton.setSelected(true);
            }
            
            //set shape selection         
            if (sh.equals(u.getArc())) {
                this.arcRadioButton.setSelected(true);
            } 
            else if (sh.equals(u.getCircle())) {
                this.circleRadioButton.setSelected(true);
            }
            else if (sh.equals(u.getGeneralPath())) {
                this.gPathRadioButton.setSelected(true);
            }
            else if (sh.equals(u.getRect())) {
                this.rectRadioButton.setSelected(true);
            }
            else if (sh.equals(u.getRoundRect())) {
                this.roundRectRadioButton.setSelected(true);
            } 
            
            
        } 
    }
    
    
    public static void main(String[] args) {
        PainterView window = new PainterView("Painter");
        window.pack();
        window.setSize(800,510);
        window.setResizable(false);
        window.setVisible(true);
    }
}
